declare 

v_field_id NUMBER(14);
v_dataspy_id NUMBER(14);
v_col_ord NUMBER;
DataSpyName varchar(50);
GridName varchar(20);

DataSpyExists number(1);
ExistingDataSpyId number(14);
sequence_check varchar2(3);

begin

DataSpyName := 'Manufacturer Part Numbers - AM';
GridName := 'LVMANUPART';

-- Cleanup

select count(*) into DataSpyExists
from r5dddataspy ds
inner join r5grid g on ds.dds_gridid = g.grd_gridid
where dds_ddspyname = DataSpyName
and g.grd_gridname = GridName
and rownum = 1;

IF DataSpyExists = 1 THEN

    select ds.dds_ddspyid into ExistingDataSpyId
    from r5dddataspy ds
    inner join r5grid g on ds.dds_gridid = g.grd_gridid
    where ds.dds_ddspyname = DataSpyName
    and g.grd_gridname = GridName;
    
    delete from r5queryfield where dqf_ddspyid = ExistingDataSpyId;
    delete from r5dddataspy where dds_ddspyid = ExistingDataSpyId;
END IF;

-- Insert new DataSpy and QueryField

--select max(dds_ddspyid)+1 into v_dataspy_id from r5dddataspy;
r5o7.o7maxseq(v_dataspy_id, 'DDS', '1', sequence_check);

insert into R5dddataspy
(
    DDS_DDSPYNAME,
    DDS_DDSPYID,
    DDS_AUTORUN,
    DDS_SCOPE,
    DDS_ORGANIZATION,
    DDS_UPDATESTAMP,
    DDS_UPDATEBYUSER,
    DDS_CREATEDSTAMP,
    DDS_UPDATEABLE,
    DDS_FILTERSTRXML,
    DDS_SORTSTRXML,
    DDS_FIELDLIST,
    DDS_UPDATECOUNT,
    DDS_DISPLAYROW,
    DDS_OWNER,
    DDS_GRIDID,
    DDS_TYPE,
    DDS_DEFAULTFLAG,
    DDS_FIELDLIST_PORTLET,
    DDS_CLIENTROWS,
    DDS_PORTLETROWS,
    DDS_HINTS,
    DDS_BOTNAME,
    DDS_USERFILTER,
    DDS_SECURITYDATASPY,
    DDS_MEKEY
)
select
    DataSpyName,
    v_dataspy_id,
    '-',
    '-',
    DDS_ORGANIZATION,
    DDS_UPDATESTAMP,
    DDS_UPDATEBYUSER,
    DDS_CREATEDSTAMP,
    DDS_UPDATEABLE,
    DDS_FILTERSTRXML,
    DDS_SORTSTRXML,
    DDS_FIELDLIST,
    DDS_UPDATECOUNT,
    DDS_DISPLAYROW,
    DDS_OWNER,
    DDS_GRIDID,
    'UD',
    '-',
    DDS_FIELDLIST_PORTLET,
    DDS_CLIENTROWS,
    DDS_PORTLETROWS,
    DDS_HINTS,
    NULL,
    DDS_USERFILTER,
    DDS_SECURITYDATASPY,
    DDS_MEKEY
from R5dddataspy ds, r5grid g
where ds.dds_gridid = g.grd_gridid
and g.grd_gridname = GridName
and ds.dds_defaultflag = '+';

insert into r5queryfield
(
    DQF_DDSPYID,
    DQF_FIELDID,
    DQF_COLUMNWIDTH,
    DQF_COLUMNORDER,
    DQF_UPDATECOUNT,
    DQF_VIEWTYPE
)
select
    v_dataspy_id,
    DQF_FIELDID,
    DQF_COLUMNWIDTH,
    DQF_COLUMNORDER,
    DQF_UPDATECOUNT,
    DQF_VIEWTYPE
from r5queryfield q, R5dddataspy ds, r5grid g, r5gridfield gf
where q.dqf_ddspyid = ds.dds_ddspyid
AND ds.dds_gridid = g.grd_gridid
AND q.dqf_fieldid = gf.gfd_fieldid
AND gf.gfd_gridid = g.grd_gridid
and g.grd_gridname = GridName
and ds.dds_defaultflag = '+'
and q.dqf_viewtype = 'LIST'
order by g.grd_gridname, gf.GFD_BOTNUMBER;

commit;

end;


/